;;;
;;;
;;; 

INIT:
	; Initialize SIO/0
	IN	A,(SIOAC)
	IN	A,(SIOBC)
	; Reset both Ch.
	LD	A,18H
	OUT	(SIOAC),A
	OUT	(SIOBC),A
	; Ch.B WR2 (Vector)
	LD	A,02H
	OUT	(SIOBC),A
	XOR	A
	OUT	(SIOBC),A
	; Ch.A WR1
	LD	A,01H
	OUT	(SIOAC),A
	LD	A,1AH
	OUT	(SIOAC),A
	; Ch.B WR1
	LD	A,01H
	OUT	(SIOBC),A
	LD	A,1EH
	OUT	(SIOBC),A
	; Ch.A WR4
	LD	A,04H
	OUT	(SIOAC),A
	LD	A,44H
	OUT	(SIOAC),A
	; Ch.A WR3
	LD	A,03H
	OUT	(SIOAC),A
	LD	A,0C1H
	OUT	(SIOAC),A
	; Ch.A WR5
	LD	A,05H
	OUT	(SIOAC),A
	LD	A,68H
	OUT	(SIOAC),A

	RET

    ;
; SIO Ch.A conin/const/conout w/o interrupt
;

CONIN:
	IN	A,(SIOAC)
	AND	01H
	JR	Z,CONIN
	IN	A,(SIOAD)
	RET

CONST:
	IN	A,(SIOAC)
	AND	01H
	RET

CONOUT:
	PUSH	AF
CO0:
	IN	A,(SIOAC)
	AND	04H
	JR	Z,CO0
	POP	AF
	OUT	(SIOAD),A
	RET

EEREAD:
        PUSH	BC
	PUSH	DE
EER0:
	CALL	EESTART
	LD	A,0A0H
	CALL	EEWBYTE
	CALL	EERACK
	JR	C,EER0
	LD	A,H
	CALL	EEWBYTE
	CALL	EERACK
        LD	A,L
	CALL	EEWBYTE
	CALL	EERACK
	CALL	EESTART
	LD	A,0A1H
	CALL	EEWBYTE
	CALL	EERACK
	CALL	EERBYTE
	PUSH	AF
	CALL	EEWNAK
	CALL	EESTOP
	POP	AF
	POP	DE
	POP	BC
	RET

EEWRITE:
	PUSH	BC
	PUSH	DE
	PUSH	AF
EEW0:
	CALL	EESTART
	LD	A,0A0H
	CALL	EEWBYTE
	CALL	EERACK
	JR	C,EEW0
	LD	A,H
	CALL	EEWBYTE
	CALL	EERACK
	LD	A,L
	CALL	EEWBYTE
	CALL	EERACK
	POP	AF
	CALL	EEWBYTE
	CALL	EERACK
	CALL	EESTOP
	POP	DE
	POP	BC
	RET

EESTART:
	SCF
	CALL	SETSCL
	AND	A
	CALL	SETSDA
	AND	A
	CALL	SETSCL
	RET

EESTOP:
	AND	A
	CALL	SETSDA
	SCF
	CALL	SETSCL
	SCF
	CALL	SETSDA
	RET

EEWBYTE:
	LD	B,8
EEWB0:
	RLA
	PUSH	AF
	CALL	SETSDA
	SCF
	CALL	SETSCL
	AND	A
	CALL	SETSCL
	POP	AF
	DJNZ	EEWB0
	RET

EERACK:
	SCF
	CALL	SETSDA
	SCF
	CALL	SETSCL
	CALL	GETSDA
	PUSH	AF
	AND	A
	CALL	SETSCL
	POP	AF
	RET

EERBYTE:
	LD	B,8
EERB0:
	CALL	GETSDA
	RL	D
	SCF
	CALL	SETSCL
	AND	A
	CALL	SETSCL
	DJNZ	EERB0
	LD	A,D
	RET

EEWACK:
	AND	A
	CALL	SETSDA
	SCF
	CALL	SETSCL
	AND	A
	CALL	SETSCL
	RET

EEWNAK:
	SCF
	CALL	SETSDA
	SCF
	CALL	SETSCL
	AND	A
	CALL	SETSCL
	RET

SETSDA:
	DI
	LD	C,0
	CCF
	RR	C
	LD	A,68H
	OR	C
	PUSH	AF
	LD	A,05H	; WR5
	OUT	(SIOAC),A
	POP	AF
	OUT	(SIOAC),A
	EI
	RET
	
SETSCL:
	DI
	LD	C,0
	CCF
	RR	C
	LD	A,68H
	OR	C
	PUSH	AF
	LD	A,05H	; WR5
	OUT	(SIOBC),A
	POP	AF
	OUT	(SIOBC),A
	EI
	RET

GETSDA:
	DI
	LD	A,010H	; 
	OUT	(SIOAC),A
	IN	A,(SIOAC)
	RRA
	RRA
	RRA
	RRA
	CCF
	EI
	RET

